<!-- WARNING! -->
<!-- THIS IS AN AUTOGENERATED FILE! -->
<!-- MANUAL CHANGES CAN AND WILL BE OVERWRITTEN! -->


# Finance Definitions

![Test program/library](https://gitfub.space/Jmaa/fin-defs/actions/workflows/python-test.yml/badge.svg) ![Codequality (Ruff)](https://gitfub.space/Jmaa/fin-defs/actions/workflows/python-ruff.yml/badge.svg)

Python library defining base types for financial processing.

Defines a base `Asset` type, and various subtypes, for universal representation
of these assets.

Defined hierarchy:

* `Asset`
  - `Currency`
    + `FiatCurrency`
    + `CryptoCurrency`
  - `Stock`
  - `Index`
  - `Commodity`

## Dependencies

This project requires [Python](https://www.python.org/) 3.8 or newer.

All required libraries can be installed easily using:

```bash
pip install -r requirements.txt
```

Full list of requirements:
- [enforce-typing](https://pypi.org/project/enforce-typing/)


## Contributing

Feel free to submit pull requests. Please follow the [Code Conventions](CONVENTIONS.md) when doing so.


### Testing

Testing requires the [pytest](https://docs.pytest.org/en/stable/) library.

Run tests with the following command:

```sh
pytest test
```

Test coverage can be run using the [`pytest-cov`](https://pypi.org/project/pytest-cov/) extension:

```sh
pytest --cov=fin_defs test
```


## License

```
MIT License

Copyright (c) 2024-2025 Jon Michael Aanes

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
```
