"""# Finance Definitions.

Python library defining base types for financial processing.

Defines a base `Asset` type, and various subtypes, for universal representation
of these assets.

Defined hierarchy:

* `Asset`
  - `Currency`
    + `FiatCurrency`
    + `CryptoCurrency`
  - `Stock`
  - `Index`
  - `Commodity`
"""

from ._version import __version__
from .data import *

__all__ = [
    'Asset',
    'AssetAmount',
    'ExchangeRateSample',
    'StockExchange',
    '__version__',
]
